#!/usr/bin/env python

import sys
sys.path.insert(0,"../..")
import gladex_functions as gxf
import gtk
import os
import re
import string
import inspect

plugdir =os.path.split(__file__)[0]
widgets = {}
tree = None

def info():
	pass
info.name="Perl Generator"
info.version=1
info.compatibility=0.4
info.description="""This plugin will ouput gkt glade stuff in perl.
You need:
libglade-perl
libgladexml-perl
libgtk2-xml-perl
 in order for the perl gtk bindings to work."""
info.plugin_type="generator"


def widget():
	global tree, widgets,plugdir
	#parent_data = parent_input
		
	if widgets.has_key("main_widget"):
		update_feilds()
		return widgets["main_widget"]
	
	gladefile = plugdir+'/perl.glade'
	tree = gtk.glade.XML(gladefile)
	widgets["main_widget"] = tree.get_widget("main_widget")
	dic ={"on_style_info_clicked":on_style_info_clicked}
	tree.signal_autoconnect(dic)
	
	widgets["main_package_name"] = tree.get_widget("main_package_name")
	widgets["callbacks_package_name"] = tree.get_widget("callbacks_package_name")
	widgets["style"] = tree.get_widget("style")
	widgets["style"].set_active(0)
	widgets["tab"] = tree.get_widget("tab")
	widgets["tab"].set_active(0)
	widgets["glade_file_entry"] = gxf.get_gladex_tree().get_widget("glade_file_chooser")
	
	
	update_feilds()
	
	return widgets["main_widget"]
#
def update_feilds():
	glade_file_title = widgets["glade_file_entry"].get_filename()
	if glade_file_title is not None:
		glade_file_title = glade_file_title[glade_file_title.rfind('/')+1:glade_file_title.rfind('.')]
	else:
		glade_file_title="examle"
	widgets["main_package_name"].set_text(glade_file_title+".pl")
	widgets["callbacks_package_name"].set_text(glade_file_title+"Callbacks.pm")
	#widgets["style"]
	#widgets["tab"]
#

def execute():
	## check in all feilds
	gxt = gxf.get_gladex_tree()
	working_dir = gxt.get_widget("output_directory_chooser").get_filename()
	glade_file_name = gxt.get_widget("glade_file_chooser").get_filename()
	style = tree.get_widget("style").get_active_text()
	indentation = tree.get_widget("tab").get_active_text()
	main_file_name = widgets["main_package_name"].get_text()
	callbacks_file_name = widgets["callbacks_package_name"].get_text()
	
	
	glade_file = gxf.File(glade_file_name)
	callbacks_file = gxf.File(callbacks_file_name)
	main_file = gxf.File(main_file_name)
	
	## validate feilds
	if glade_file.ext != "glade":
		return "glade file must end in .glade"
	
	if callbacks_file.ext != "pm":
		return "callbacks file must end in .pm"
	
	if main_file.ext != "pl":
		return "python file must end in .pl"
	
	
	if indentation == "" or style == "":
			return "please select a indetation and style type"
	if indentation == "tab":
		indent = "\t"
	elif indentation == "4 spaces":
		indent = "    "
	else:
		indent = "\t"
	
	## get callbacks functions
	callbacks = gxf.get_handlers()
	
	### style classic #####################
	if style == "Minimal":
		styledir = plugdir+"/styles/re-gen/"
	### style no regeneration #############
	if style == "Full": 
		styledir = plugdir+"/styles/no-re-gen/"
		#return "this style is not working yet"
	
	replace = {
		"{I}":indent,
		"{CALLBACKS_TITLE}":callbacks_file.title,
		"{CALLBACKS_TITLE_EXT}":callbacks_file.title_ext,
		"{GLADE_TITLE_EXT}":glade_file.title_ext
		}
	
	#input files
	gxf.file_copy(glade_file_name, working_dir+"/")
	
	outputdir = working_dir+"/"
	#python file writeout useing template and replace variable
	inmain = gxf.File(styledir+"main.template", "r")
	outmain = gxf.File(outputdir+main_file.title_ext, "w")
	main = gxf.Gxio(inmain, outmain)
	main.replace(replace)
	main.write_out(0755)
	inmain.close()
	outmain.close()
	
	#callbacks file writeout
	#detects if data exsist, if so, do not write header
	#in both cases, write new callbacks to callbacks file
	
	##outcall = gxf.File(outputdir+callbacks_file.title_ext, "r+")
	## outcall_text = outcall.read_text() 
	if not os.path.exists(outputdir+callbacks_file.title_ext):
		outcall = gxf.File(outputdir+callbacks_file.title_ext, "w+")
		#outcall.seek(0)
		incall = gxf.File(styledir+"callbacks.template", "r")
		#text = incall.read_text()
		#print text
		call = gxf.Gxio(incall, outcall)
		call.replace(replace)
		call.replace({"1;":""})
		text = call.get_text()+"\n"
		text += get_callback_functions(outputdir,outcall.title_ext)
		text += "\n\n1;"
		#print "#############HERE##################";
		call.set_text(text)
		call.write_out()
		incall.close()
	else:
		outcall = gxf.File(outputdir+callbacks_file.title_ext, "r")
		text = outcall.read_text()
		outcall.close()
		outcall = gxf.File(outputdir+callbacks_file.title_ext, "w")
		text = text.replace("1;","")
		text += "\n"+get_callback_functions(outputdir,outcall.title_ext,text)
		text += "\n\n1;"
		#print "##text to write###\n",text,"\n###############";
		outcall.write_text(text)
	outcall.close()
	
	return "Job done. please open up the output\ndirectory to see the generated code."
#

def get_old_callbacks(odir, ofilename, textoption=None):
	if textoption==None:
		oldtext = open(odir+ofilename,'r').readlines()
	else:
		oldtext = textoption.split("\n")
	oldcalls=[]
	#print "oldtextf: ",odir+ofilename
	for line in oldtext:
		m = re.match("sub",line)
		if(m):
			line = re.sub("sub ","",line)
			line = re.sub("{","",line)
			oldcalls.append(str(line).replace("\n",""))#m.group())
	return oldcalls
#

def get_callback_functions(odir, ofilename,textoption=None):
	handlers = gxf.get_handlers()
	a = ''
	oldfunctions = get_old_callbacks(odir, ofilename,textoption)
	#print "########### old functions:",oldfunctions
	#print "########### handlers:",handlers
	for hand in handlers:
		if hand not in oldfunctions:
			a += "sub "+hand+"{\n\tprint \"function '"+hand+"' not implmented\\n\";\n}\n"
		#else: print "blocking"
	#a += "\n\n1;"
	return a
#

def on_glade_file_change(widget):
	update_feilds()
	pass
#

def on_directory_change(widget):
	pass
#

def on_style_info_clicked(widget="", event="", data=""):
	style = tree.get_widget("style")
	style_name = style.get_active_text()
	message = ""
	if style_name == "Minimal":
		message = """Perl Minimal code generation
	This plugin will genrate a callbacks file with
	the callbacks defined in the glade file. If new
	callbacks are defined the user must write in the 
	callbacks themself.
	"""
	if style_name == "Full":
		message = """Perl Full code generation
	This plugin will include the required code to 
	place new callback in the callbacks file. Use 
	the command line to access this feture.
	cd /path/tolocation/of/perlfile/
	./perlfilename.pl update
	sending the update pramater will update the
	 callbacks file.
	"""
	gxf.show_message(message)
#


